package org.jeecg.modules.stm.project.execpro.controller;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.SpringContextUtils;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;
import org.jeecg.modules.stm.project.create.entity.StProjectCheck;
import org.jeecg.modules.stm.project.create.service.IStProjectCheckService;
import org.jeecg.modules.stm.project.exec.entity.StProjectExec;
import org.jeecg.modules.stm.project.exec.service.IStProjectExecService;
import org.jeecg.modules.stm.project.execpro.entity.StProjectExecPro;
import org.jeecg.modules.stm.project.execpro.service.IStProjectExecProService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 项目实施问题
 * @Author: jeecg-boot
 * @Date:   2023-08-17
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/project.execpro/stProjectExecPro")
@Slf4j
public class StProjectExecProController extends JeecgController<StProjectExecPro, IStProjectExecProService> {
	@Autowired
	private IStProjectExecProService stProjectExecProService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stProjectExecPro
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "项目实施问题-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<StProjectExecPro>> queryPageList(StProjectExecPro stProjectExecPro,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		String projectCreId = req.getParameter("projectCreId");
		QueryWrapper<StProjectExecPro> queryWrapper = QueryGenerator.initQueryWrapper(stProjectExecPro, req.getParameterMap());
		if(StringUtils.hasText(projectCreId)){
			IStProjectCheckService iStProjectCheeckService = SpringContextUtils.getBean(IStProjectCheckService.class);
			QueryWrapper<StProjectCheck> checkQueryWrapper = new QueryWrapper<>();
			checkQueryWrapper.eq("PROJECT_CRE_ID",projectCreId);
			List<StProjectCheck> stProjectCheckList = iStProjectCheeckService.list(checkQueryWrapper);
			if(CollectionUtils.isEmpty(stProjectCheckList)){
				queryWrapper.eq("PROJECT_EXEC_ID","noExist");
			}else {
				List<Integer> checkIds = stProjectCheckList.stream().map(StProjectCheck::getId).collect(Collectors.toList());
				IStProjectExecService iStProjectExecService = SpringContextUtils.getBean(IStProjectExecService.class);
				QueryWrapper<StProjectExec> stProjectExecQueryWrapper = new QueryWrapper<>();
				stProjectExecQueryWrapper.in("project_check_id",checkIds);
				List<StProjectExec> stProjectExecList = iStProjectExecService.list(stProjectExecQueryWrapper);
				List<Integer> execIds = stProjectExecList.stream().map(StProjectExec::getId).collect(Collectors.toList());
				if(CollectionUtils.isEmpty(execIds)){
					queryWrapper.eq("PROJECT_EXEC_ID","noExist");
				}else {
					queryWrapper.in("PROJECT_EXEC_ID", execIds);
				}
			}
		}
		Page<StProjectExecPro> page = new Page<StProjectExecPro>(pageNo, pageSize);
		IPage<StProjectExecPro> pageList = stProjectExecProService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param stProjectExecPro
	 * @return
	 */
	@AutoLog(value = "项目实施问题-添加")
	  
	@RequiresPermissions("project.execpro:st_project_exec_pro:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StProjectExecPro stProjectExecPro) {
		stProjectExecProService.save(stProjectExecPro);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stProjectExecPro
	 * @return
	 */
	@AutoLog(value = "项目实施问题-编辑")
	  
	@RequiresPermissions("project.execpro:st_project_exec_pro:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StProjectExecPro stProjectExecPro) {
		stProjectExecProService.updateById(stProjectExecPro);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "项目实施问题-通过id删除")
	  
	@RequiresPermissions("project.execpro:st_project_exec_pro:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stProjectExecProService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "项目实施问题-批量删除")
	  
	@RequiresPermissions("project.execpro:st_project_exec_pro:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stProjectExecProService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "项目实施问题-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<StProjectExecPro> queryById(@RequestParam(name="id",required=true) String id) {
		StProjectExecPro stProjectExecPro = stProjectExecProService.getById(id);
		if(stProjectExecPro==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stProjectExecPro);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param stProjectExecPro
    */
    @RequiresPermissions("project.execpro:st_project_exec_pro:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StProjectExecPro stProjectExecPro) {
        return super.exportXls(request, stProjectExecPro, StProjectExecPro.class, "项目实施问题");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("project.execpro:st_project_exec_pro:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, StProjectExecPro.class);
    }

}
